#include "stdafx.h"
#include "game_sv_deathmatch.h"
#include "HUDmanager.h"
#include "xrserver_objects_alife_monsters.h"
#include "ui\UIBuyWeaponWnd.h"
#include "level.h"
#include "xrserver.h"
#include "Inventory.h"
#include "CustomZone.h"
#include "../igame_persistent.h"
#include "clsid_game.h"
#include "Actor.h"
#include "game_cl_base.h"
#include "xr_level_controller.h"
#include "hudItem.h"
#include "weapon.h"

//#define DELAYED_ROUND_TIME	7000

#define UNBUYABLESLOT		20

game_sv_Deathmatch::game_sv_Deathmatch()
{
	type = GAME_DEATHMATCH;
	
	m_dwLastAnomalySetID	= 1001;
	m_dwLastAnomalyStartTime = 0;

	m_delayedRoundEnd = false;
	m_dwLastAnomalyStartTime = 0;

	m_bSpectatorMode = false;
	m_dwSM_CurViewEntity = 0;
	m_pSM_CurViewEntity = NULL;
	m_dwSM_LastSwitchTime = 0;

	m_bDamageBlockIndicators = false;

	//-------------------------------
	m_vFreeRPoints.clear();
	m_dwLastRPoint = u32(-1);
	//-------------------------------
	m_dwWarmUp_MaxTime = 0;
	m_dwWarmUp_CurTime = 0;
};

game_sv_Deathmatch::~game_sv_Deathmatch()
{
	if (!m_AnomalySetsList.empty())
	{
		for (u32 i=0; i<m_AnomalySetsList.size(); i++)
		{
			m_AnomalySetsList[i].clear();
		};
		m_AnomalySetsList.clear();
	};

	if (!m_AnomalyIDSetsList.empty())
	{
		for (u32 i=0; i<m_AnomalyIDSetsList.size(); i++)
		{
			m_AnomalyIDSetsList[i].clear();
		};
		m_AnomalyIDSetsList.clear();
	};
	
	m_AnomalySetID.clear();
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_CLEAR("sv_dmgblockindicator");

	//-------------------------------------------------------------
	m_vFreeRPoints.clear();
};

void	game_sv_Deathmatch::Create					(shared_str& options)
{
	inherited::Create						(options);
	//-----------------------------------------------------------------------
	/////////////////////////////////////////////////////////////////////////
	LoadTeams();
	/////////////////////////////////////////////////////////////////////////
	switch_Phase(GAME_PHASE_PENDING);
//	switch_Phase(GAME_PHASE_INPROGRESS);

	::Random.seed(GetTickCount());
	/////////////////////////////////////////////////////////////////////////
	m_CorpseList.clear();

	m_AnomaliesPermanent.clear();
	m_AnomalySetsList.clear();
	m_AnomalySetID.clear();	
	m_bPDAHunt = TRUE;
	/////////////////////////////////////////////////////////////////////////
	
}

void	game_sv_Deathmatch::OnRoundStart			()
{
	LoadAnomalySets();
	/////////////////////////////
	m_delayedRoundEnd = false;
	pWinnigPlayerName = "";
	m_dwLastAnomalySetID	= 1001;
	/////////////////////////////////////////////////////////////////////////
	for (u32 i=0; i<teams.size(); ++i)
	{
		teams[i].score			= 0;
		teams[i].num_targets	= 0;
	};

	///////////////////////////////////////////	
	m_dwWarmUp_CurTime = 0;
	if (!m_bFastRestart)
	{
		if (m_dwWarmUp_MaxTime != 0)
		{
			m_dwWarmUp_CurTime = Level().timeServer()+m_dwWarmUp_MaxTime;
		}
	}
	//////////////////////////////////////////
	inherited::OnRoundStart	();

	//-------------------------------------
	m_vFreeRPoints.clear();
	m_dwLastRPoint = u32(-1);
	//-------------------------------------

	// Respawn all players and some info
	u32		cnt = get_players_count();
	for		(u32 it=0; it<cnt; ++it)	
	{
		SpawnPlayer(get_it_2_id(it), "spectator");
		// init
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		if (!l_pC || !l_pC->net_Ready || !l_pC->ps) continue;
		game_PlayerState* ps	= l_pC->ps;

		ps->clear();
		ps->DeathTime = Device.dwTimeGlobal;
		//---------------------------------------
		SetPlayersDefItems		(ps);
		//---------------------------------------
		Money_SetStart			(get_it_2_id(it));
		//---------------------------------------

		if (ps->Skip) continue;
	}
	
}

void	game_sv_Deathmatch::OnRoundEnd				(LPCSTR reason)
{
	switch (Phase())
	{
	case GAME_PHASE_INPROGRESS:
		{
			u32		cnt = get_players_count();
			for		(u32 it=0; it<cnt; ++it)	
			{
				xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
				game_PlayerState* ps	= l_pC->ps;
				if (!ps) continue;
				if (ps->Skip) continue;
				SpawnPlayer(get_it_2_id(it), "spectator");
			};
		}break;
	}
	inherited::OnRoundEnd(reason);
};

void	game_sv_Deathmatch::OnPlayerKillPlayer		(game_PlayerState* ps_killer, game_PlayerState* ps_killed, KILL_TYPE KillType, SPECIAL_KILL_TYPE SpecialKillType, CSE_Abstract* pWeaponA)
{
	Processing_Victim(ps_killed, ps_killer);

	signal_Syncronize();

	if (!ps_killed || !ps_killer) return;
	
	KILL_RES KillRes = GetKillResult (ps_killer, ps_killed);
	bool CanGiveBonus = OnKillResult(KillRes, ps_killer, ps_killed);
	if (CanGiveBonus) OnGiveBonus(KillRes, ps_killer, ps_killed, KillType, SpecialKillType, pWeaponA);
}

void				game_sv_Deathmatch::Processing_Victim		(game_PlayerState* pVictim, game_PlayerState* pKiller)
{
	if (!pVictim) return;
	
	pVictim->setFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD);
	pVictim->deaths				+=	1;
	pVictim->m_iKillsInRow		= 0;
	pVictim->DeathTime			= Device.dwTimeGlobal;		
	if (!pKiller)
		pVictim->kills -=1;

	SetPlayersDefItems		(pVictim);

	Victim_Exp				(pVictim);
	//---------------------------------------
	Game().m_WeaponUsageStatistic.OnPlayerKilled(pVictim);
	//---------------------------------------
};

void				game_sv_Deathmatch::Victim_Exp				(game_PlayerState* pVictim)
{
	Set_RankUp_Allowed(true);
	Player_AddExperience(pVictim, 0.0f);
	Set_RankUp_Allowed(false);
};

KILL_RES			game_sv_Deathmatch::GetKillResult			(game_PlayerState* pKiller, game_PlayerState* pVictim)
{
	if (!pKiller || !pVictim) return KR_NONE;

	if (pKiller == pVictim) return KR_SELF;
	return KR_RIVAL;
};

bool				game_sv_Deathmatch::OnKillResult			(KILL_RES KillResult, game_PlayerState* pKiller, game_PlayerState* pVictim)
{
	if (!pKiller || !pVictim) return false;
	bool res = true;
	TeamStruct* pTeam		= GetTeamData(u8(pKiller->team));
	switch (KillResult)
	{
	case KR_NONE:
		{
			res = false;
		}break;
	case KR_SELF:
		{
			pKiller->kills -= 1;
			if (pTeam) Player_AddMoney(pKiller, pTeam->m_iM_KillSelf);
			res = false;
		}break;
	case KR_RIVAL:
		{
			pKiller->kills += 1;
			pKiller->m_iKillsInRow ++;
			if (pTeam)
			{
				s32 ResMoney = pTeam->m_iM_KillRival;
				if (pKiller->testFlag(GAME_PLAYER_FLAG_INVINCIBLE))
					ResMoney = s32(ResMoney * pTeam->m_fInvinsibleKillModifier);
				Player_AddMoney(pKiller, ResMoney);
			};
			res = true;
		}break;
	default:
		{
		}break;
	}
	return res;
}

void				game_sv_Deathmatch::OnGiveBonus				(KILL_RES KillResult, game_PlayerState* pKiller, game_PlayerState* pVictim, KILL_TYPE KillType, SPECIAL_KILL_TYPE SpecialKillType, CSE_Abstract* pWeaponA)
{
	if (!pKiller) return;
	switch (KillResult)
	{
	case KR_RIVAL:
		{
			switch (KillType)
			{
			case KT_HIT:
				{
					switch (SpecialKillType)
					{
					case SKT_HEADSHOT:
						{
							Player_AddExperience(pKiller, READ_IF_EXISTS(pSettings, r_float, "mp_bonus_exp", "headshot",0));
							Player_AddBonusMoney(pKiller, READ_IF_EXISTS(pSettings, r_s32, "mp_bonus_money", "headshot",0), SKT_HEADSHOT);
						}break;
					case SKT_BACKSTAB:
						{
							Player_AddBonusMoney(pKiller, READ_IF_EXISTS(pSettings, r_s32, "mp_bonus_money", "backstab",0), SKT_BACKSTAB);
						}break;
					default:
						{
							if (pWeaponA)
							{								
								switch (pWeaponA->m_tClassID)
								{
								case CLSID_OBJECT_W_KNIFE:
									{
										Player_AddBonusMoney(pKiller, READ_IF_EXISTS(pSettings, r_s32, "mp_bonus_money", "knife_kill",0), SKT_KNIFEKILL);
									}break;
								};
							};
						}break;
					};
				}break;
			default:
				{
				}break;
			};

			if (pKiller->m_iKillsInRow)
			{
				string64 tmpStr;
				sprintf(tmpStr, "%d_kill_in_row", pKiller->m_iKillsInRow);
				Player_AddBonusMoney(pKiller, READ_IF_EXISTS(pSettings, r_s32, "mp_bonus_money", tmpStr,0), SKT_KIR, u8(pKiller->m_iKillsInRow & 0xff));
			};			
		}break;
	default:
		{
		}break;
	}
}

game_PlayerState*	game_sv_Deathmatch::GetWinningPlayer		()
{
	game_PlayerState* res = NULL;
	s16 MaxFrags	= -1;

	u32		cnt		= get_players_count	();
	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!ps) continue;
		if (ps->kills > MaxFrags)
		{
			MaxFrags = ps->kills;
			res = ps;
		}
	};
	return res;
};

void	game_sv_Deathmatch::OnPlayerScores()
{
	game_PlayerState* pWinner = GetWinningPlayer();
	if (pWinner)
	{
		pWinnigPlayerName = pWinner->getName();
		phase = GAME_PHASE_PLAYER_SCORES;
		switch_Phase		(phase);
		OnDelayedRoundEnd("Player Scores");
	}
};

void	game_sv_Deathmatch::OnTimelimitExceed		()
{
	OnRoundEnd	("TIME_limit");
	OnPlayerScores();
}
void	game_sv_Deathmatch::OnFraglimitExceed		()
{
	OnRoundEnd	("FRAG_limit");
	OnPlayerScores();
}

#include "UIGameDM.h"
void	game_sv_Deathmatch::Update					()
{
	inherited::Update	();

	switch ( Phase() )
	{
	case GAME_PHASE_INPROGRESS:
		{
			checkForRoundEnd();
			
			check_InvinciblePlayers();

			check_ForceRespawn();

			check_for_Anomalies();

			if (m_bSpectatorMode)
			{
				if (!m_pSM_CurViewEntity || m_pSM_CurViewEntity->CLS_ID != CLSID_OBJECT_ACTOR || m_dwSM_LastSwitchTime<Level().timeServer())
					SM_SwitchOnNextActivePlayer();
				
				CUIGameDM* GameDM = smart_cast<CUIGameDM*>(HUD().GetUI()->UIGame());
				if (GameDM) GameDM->SetSpectrModeMsgCaption("");

				CObject* pObject = Level().CurrentViewEntity();
				if (pObject && pObject->CLS_ID == CLSID_OBJECT_ACTOR)
				{
					char Text[1024];
					sprintf(Text, "Following %s", pObject->cName().c_str());

					if (GameDM) GameDM->SetSpectrModeMsgCaption(Text);
				};
			};

			check_for_WarmUp();
		}
		break;
	case GAME_PHASE_PENDING:
		{
			checkForRoundStart();
		}
		break;
	case GAME_PHASE_PLAYER_SCORES:
		{
			if(m_delayedRoundEnd && m_roundEndDelay < Device.TimerAsync())
				OnRoundEnd("Finish");
		} break;
	}
}

INT	g_sv_Pending_Wait_Time = 10000;
INT g_sv_Wait_For_Players_Ready = 1;
bool game_sv_Deathmatch::checkForRoundStart()
{
	if (m_bFastRestart ||
		(AllPlayers_Ready() || (
#ifdef DEBUG
		!g_sv_Wait_For_Players_Ready &&
#endif		
		(((Level().timeServer()-start_time))>u32(g_sv_Pending_Wait_Time)))
		)
		)
	{
		if (!SwitchToNextMap() || !OnNextMap())
		{
			OnRoundStart();
		};
		return true;
	};

	return false;
}

bool game_sv_Deathmatch::checkForTimeLimit()
{
	if (timelimit && ((Level().timeServer()-start_time)) > u32(timelimit) )
	{
		if (!HasChampion()) return false;
		OnTimelimitExceed();
		return true;
	};
	return false;
}

bool game_sv_Deathmatch::checkForFragLimit()
{
	if( fraglimit )
	{
		u32		cnt		= get_players_count	();
		for		(u32 it=0; it<cnt; ++it)	
		{
			game_PlayerState* ps		=	get_it	(it);
			if (ps->kills >= fraglimit ){
				OnFraglimitExceed();
				return true;
			}
		}
	}
	return false;
}

bool game_sv_Deathmatch::checkForRoundEnd()
{

	if( checkForTimeLimit() )
			return true;

	if( checkForFragLimit() )
			return true;

	return false;
}


void	game_sv_Deathmatch::SM_SwitchOnNextActivePlayer()
{
	if (!m_bSpectatorMode) return;
	u32		PossiblePlayers[32];
	u32		cnt		= get_players_count	();
	u32		PPlayersCount = 0;

	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!l_pC->net_Ready) continue;
		if (ps->Skip) continue;
		if (ps->testFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD)) continue;
		PossiblePlayers[PPlayersCount++] = it;
	};
	
	
	CObject* pNewObject = NULL;
	if (!PPlayersCount)
	{
		xrClientData*	C = (xrClientData*) m_server->GetServerClient();
		pNewObject =  Level().Objects.net_Find(C->ps->GameID);
	}
	else
	{
		it	= PossiblePlayers[::Random.randI((int)PPlayersCount)];
		xrClientData*	C = NULL;
		C	= (xrClientData*)m_server->client_Get			(it);	
		pNewObject =  Level().Objects.net_Find(C->ps->GameID);
		CActor* pActor = smart_cast<CActor*>(pNewObject);
		if (!pActor || !pActor->g_Alive() || !pActor->inventory().ActiveItem()) return;
	};
	SM_SwitchOnPlayer(pNewObject);
};

#include "WeaponHUD.h"

void	game_sv_Deathmatch::SM_SwitchOnPlayer(CObject* pNewObject)
{
	if (!pNewObject || !m_bSpectatorMode) return;

	Level().SetEntity(pNewObject);
	if (pNewObject != m_pSM_CurViewEntity)
	{
		CActor* pActor = smart_cast<CActor*> (m_pSM_CurViewEntity);
		if (pActor)
			pActor->inventory().Items_SetCurrentEntityHud(false);
	}
	CActor* pActor = smart_cast<CActor*> (pNewObject);
	if (pActor)
	{
		pActor->inventory().Items_SetCurrentEntityHud(true);

		CHudItem* pHudItem = smart_cast<CHudItem*>(pActor->inventory().ActiveItem());
		if (pHudItem) 
		{
			pHudItem->OnStateSwitch(pHudItem->State());
		};
	}
	m_pSM_CurViewEntity = pNewObject;
	m_dwSM_CurViewEntity = pNewObject->ID();
	m_dwSM_LastSwitchTime = Level().timeServer() + m_dwSM_SwitchDelta;
}


BOOL	game_sv_Deathmatch::AllPlayers_Ready ()
{
	if (!m_server->GetServerClient()) return FALSE;	
	// Check if all players ready
	u32		cnt		= get_players_count	();
	u32		ready	= 0;
	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!l_pC->net_Ready)
		{
			if (l_pC->ID == m_server->GetServerClient()->ID)
			{
				continue;
			}
			++ready;
		};
		if (ps->testFlag(GAME_PLAYER_FLAG_READY) )	++ready;
		else
			if (ps->Skip) ++ready;
	}

	if (ready == cnt && ready != 0) return TRUE;
	return FALSE;
};
	

void	game_sv_Deathmatch::OnPlayerReady			(ClientID id)
{
//	if	(GAME_PHASE_INPROGRESS == phase) return;
	switch (phase)
	{
	case GAME_PHASE_PENDING:
		{
			game_PlayerState*	ps	=	get_id	(id);
			if (ps)
			{
				if (ps->testFlag(GAME_PLAYER_FLAG_READY) )	
				{
					ps->resetFlag(GAME_PLAYER_FLAG_READY);
				} 
				else 
				{
					ps->setFlag(GAME_PLAYER_FLAG_READY);
				};
			};
		}break;
	case GAME_PHASE_INPROGRESS:
		{
//			LPCSTR	options			=	get_name_id	(id);
			xrClientData*	xrCData	= (xrClientData*)m_server->ID_to_client	(id);
			game_PlayerState*	ps	=	get_id	(id);
			if (ps->Skip) break;
			if (!(ps->testFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD))) break;
			if (ps->testFlag(GAME_PLAYER_FLAG_SPECTATOR)) break;
			xrClientData* xrSCData	=	(xrClientData*)m_server->GetServerClient();
			if (xrSCData && xrSCData->ID == id && m_bSpectatorMode) 
			{
				SM_SwitchOnNextActivePlayer();
				return;
			}
			//------------------------------------------------------------
			CSE_Abstract* pOwner = xrCData->owner;
			CSE_Spectator	*pS	=	smart_cast<CSE_Spectator*>(pOwner);
			if (pS)
			{
				if (xrSCData->ps->DeathTime + 1000 > Device.dwTimeGlobal)
				{
//					return;
				}
			}
			//------------------------------------------------------------			
			RespawnPlayer(id, false);
			pOwner = xrCData->owner;
			CSE_ALifeCreatureActor	*pA	=	smart_cast<CSE_ALifeCreatureActor*>(pOwner);
			if(pA)
			{
				SpawnWeaponsForActor(pOwner, ps);
				//---------------------------------------
				Check_ForClearRun(ps);
			}
			//-------------------------------
		}break;
	};
}


void game_sv_Deathmatch::OnPlayerDisconnect		(ClientID id_who, LPSTR Name, u16 GameID)
{
//	__super::OnPlayerDisconnect	(id_who);
	inherited::OnPlayerDisconnect	(id_who, Name, GameID);
};

u32		game_sv_Deathmatch::RP_2_Use				(CSE_Abstract* E)
{
	return 0;
};

void	game_sv_Deathmatch::assign_RP				(CSE_Abstract* E, game_PlayerState* ps_who)
{
	VERIFY				(E);
	u32		Team		= RP_2_Use(E);
	VERIFY				(rpoints[Team].size());

	CSE_Spectator		*pSpectator = smart_cast<CSE_Spectator*>(E);
	if (pSpectator)
	{
		inherited::assign_RP(E, ps_who);
		return;
	};

	CSE_ALifeCreatureActor	*pA	=	smart_cast<CSE_ALifeCreatureActor*>(E);
	if (!pA)
	{
		inherited::assign_RP(E, ps_who);
		return;
	};
	//-------------------------------------------------------------------------------
	xr_vector<RPoint>&	rp	= rpoints[Team];
//	float MinTeamPRointDist = rpoints_MinDist[Team];
	//create Enemies list
	xr_vector <u32>					pEnemies;
	xr_vector <u32>					pFriends;

	u32		cnt = get_players_count();
	for		(u32 it=0; it<cnt; ++it)	
	{
		// init
		game_PlayerState*	ps	=	get_it	(it);
		if (ps->testFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD) ) continue;
		if (ps->team == pA->s_team && !teams.empty()) pFriends.push_back(it);
		else pEnemies.push_back(it);
	};
	//-------------------------------------------------------------------------------
	if (m_vFreeRPoints.empty())
	{
		for (u32 i=0; i<rp.size(); i++)
		{
			if (i==m_dwLastRPoint) continue;
			m_vFreeRPoints.push_back(i);
		}
	};
	R_ASSERT(m_vFreeRPoints.size());
	xr_vector<RPointData>	tmpPoints;
	for (u32 i=0; i<m_vFreeRPoints.size(); i++)
	{
		RPoint&				r	= rp[m_vFreeRPoints[i]];
		float MinEnemyDist = 10000.0f;
		for (u32 e=0; e<pEnemies.size(); e++)
		{
			xrClientData* xrCData	=	m_server->ID_to_client(get_it_2_id(pEnemies[e]));
			if (!xrCData || !xrCData->owner) continue;

			CSE_Abstract* pOwner = xrCData->owner;
			float Dist = r.P.distance_to_sqr(pOwner->o_Position);

			if (MinEnemyDist > Dist) MinEnemyDist = Dist;
		};
		tmpPoints.push_back(RPointData(i, MinEnemyDist, false));
	}
	R_ASSERT(tmpPoints.size());
	std::sort(tmpPoints.begin(), tmpPoints.end());
	u32 HalfList = tmpPoints.size()/(pEnemies.empty() ? 1 : 2);
	u32 NewPointID = (HalfList) ? (tmpPoints.size()-HalfList + ::Random.randI(HalfList)) : 0;

	m_dwLastRPoint = m_vFreeRPoints[tmpPoints[NewPointID].PointID];
	m_vFreeRPoints.erase(m_vFreeRPoints.begin() + tmpPoints[NewPointID].PointID);

	RPoint&	r	= rp[m_dwLastRPoint];
//	Msg("-------------- used %d", m_dwLastRPoint);
	//-------------------------------------------------------------------------------
	/*
	u8 OldTeam = pA->s_team;
	pA->s_team = u8(Team);
	
	bool SpawnPointFound = false;
	int Pass = 0;
	int PointID = 0;
	while (!SpawnPointFound)
	{
		bool UseFreezedPoints = false;
		u16 NumRP = u16(rp.size());
		while(ps_who->pSpawnPointsList.empty())
		{
			for (u16 it=0; it < NumRP; it++)
			{
				RPoint&				r	= rp[it];
				if (it != ps_who->m_s16LastSRoint && (!IsPointFreezed(&r) || UseFreezedPoints))
					ps_who->pSpawnPointsList.push_back(it);
			}
			if (ps_who->pSpawnPointsList.empty()) UseFreezedPoints = true;
		};
		R_ASSERT(!ps_who->pSpawnPointsList.empty());
		
		if (!pEnemies.empty())
		{
			xr_deque<RPointData>			pRPDist;
			pRPDist.clear();

			u32 NumRP = ps_who->pSpawnPointsList.size();
			for (it=0; it < NumRP; it++)
			{
				u16 PointID = ps_who->pSpawnPointsList[it];
				RPoint&				r	= rp[PointID];

				float MinEnemyDist = 1000000.0f;
				for (u32 p=0; p<pEnemies.size(); p++)
				{
					xrClientData* xrCData	=	m_server->ID_to_client(get_it_2_id(pEnemies[p]));
					if (!xrCData || !xrCData->owner) continue;

					CSE_Abstract* pOwner = xrCData->owner;
					float Dist = r.P.distance_to_xz_sqr(pOwner->o_Position);

					if (MinEnemyDist > Dist) MinEnemyDist = Dist;
				};
				if (MinEnemyDist>MinTeamPRointDist || Pass == 1)
				{
					pRPDist.push_back(RPointData(it, MinEnemyDist, IsPointFreezed(&r)));
				}
			};
			if (!pRPDist.empty())
			{
				std::sort(pRPDist.begin(), pRPDist.end());
				PointID = (pRPDist.back()).PointID;
				SpawnPointFound = true;
			}
			else
			{
				R_ASSERT2(Pass==0, "Can't Find Spawn Point");
				ps_who->pSpawnPointsList.clear();
				Pass = 1;
			}
		}
		else
		{
			PointID = ::Random.randI((int)ps_who->pSpawnPointsList.size());
			SpawnPointFound = true;
		};
	};
	ps_who->m_s16LastSRoint = ps_who->pSpawnPointsList[PointID];
	
	ps_who->pSpawnPointsList.erase(ps_who->pSpawnPointsList.begin()+PointID);

	RPoint&				r	= rp[ps_who->m_s16LastSRoint];
	SetPointFreezed(&r);
*/
	E->o_Position.set	(r.P);
	E->o_Angle.set		(r.A);

//	pA->s_team = OldTeam;		
	
};

bool	game_sv_Deathmatch::IsBuyableItem			(LPCSTR	ItemName)
{
	for (u8 i=0; i<TeamList.size(); i++)
	{
		TEAM_WPN_LIST	WpnList = TeamList[i].aWeapons;
		WeaponDataStruct* pWpnS = NULL;
		if (GetTeamItem_ByName(&pWpnS, &WpnList, ItemName)) return true;
	};
	return false;
};

bool	game_sv_Deathmatch::GetBuyableItemCost		(LPCSTR	ItemName, u16* pCost)
{
	*pCost = 0;
//	WeaponDataStruct* tmpWDS = NULL;
	for (u8 i=0; i<TeamList.size(); i++)
	{
		TEAM_WPN_LIST	WpnList = TeamList[i].aWeapons;
		
		TEAM_WPN_LIST_it pWpnI	= std::find(WpnList.begin(), WpnList.end(), ItemName);
		if (pWpnI == WpnList.end() || !((*pWpnI) == ItemName)) continue;

		*pCost = (*pWpnI).Cost;
		return true;
	};
	return false;
};

void	game_sv_Deathmatch::CheckItem		(game_PlayerState*	ps, PIItem pItem, xr_vector<s16> *pItemsDesired, xr_vector<u16> *pItemsToDelete)
{
	if (!pItem || !pItemsDesired || !pItemsToDelete) return;

	WeaponDataStruct* pWpnS = NULL;
	TEAM_WPN_LIST	WpnList = TeamList[ps->team].aWeapons;
	if (!GetTeamItem_ByName(&pWpnS, &WpnList, *(pItem->object().cNameSect())))
	{
		for (u8 i=0; i<TeamList.size(); i++)
		{
			WpnList = TeamList[i].aWeapons;
			if (GetTeamItem_ByName(&pWpnS, &WpnList, *(pItem->object().cNameSect()))) break;
		};
	};
	if (!pWpnS) return;
	//-------------------------------------------
	bool	found = false;
	for (u32 it = 0; it < pItemsDesired->size(); it++)
	{
		s16 ItemID = (*pItemsDesired)[it];
		if ((ItemID & 0xff1f) != pWpnS->SlotItem_ID) continue;

		found = true;
		CWeaponAmmo* pAmmo = 	smart_cast<CWeaponAmmo*>(pItem);
		if (pAmmo)
		{
			if (pAmmo->m_boxCurr != pAmmo->m_boxSize) break;
		};
		pItemsDesired->erase(pItemsDesired->begin()+it);
		//----- Check for Addon Changes ---------------------
		CWeapon		*pWeapon	=	smart_cast<CWeapon*>(pItem);
		if (pWeapon)
		{
			u8 OldAddons  = pWeapon->GetAddonsState();
			u8 NewAddons  = u8(ItemID&0x00ff)>>0x05;
			if (OldAddons != NewAddons)
			{
				CSE_ALifeItemWeapon* pSWeapon = smart_cast<CSE_ALifeItemWeapon*>(get_entity_from_eid(pWeapon->ID()));
				if (pSWeapon)
				{
					pSWeapon->m_addon_flags.zero();
					pSWeapon->m_addon_flags.set(NewAddons, TRUE);
				}

				NET_Packet	P;
				u_EventGen(P, GE_ADDON_CHANGE, pWeapon->ID());
				P.w_u8(NewAddons);
				u_EventSend(P);
			}
		};
		//---------------------------------------------------
		break;
	};
	if (found) return;
	pItemsToDelete->push_back(pItem->object().ID());
};


void	game_sv_Deathmatch::OnPlayerBuyFinished		(ClientID id_who, NET_Packet& P)
{
	game_PlayerState*	ps	=	get_id	(id_who);
	if (!ps || ps->Skip) return;	
	
	P.r_s32(ps->LastBuyAcount);	
	if (ps->LastBuyAcount != 0) ps->m_bClearRun = false;

	xr_vector<s16>		ItemsDesired;

	u8 NumItems;
	P.r_u8(NumItems);
	for (u8 i=0; i<NumItems; i++)
	{
		s16	ItemID;
		P.r_s16(ItemID);
		ItemsDesired.push_back(ItemID);
	};

	CSE_ALifeCreatureActor*		e_Actor	= smart_cast<CSE_ALifeCreatureActor*>(get_entity_from_eid	(ps->GameID));
	CActor* pActor = smart_cast<CActor*>(Level().Objects.net_Find	(ps->GameID));
	if (pActor)
	{
		PIItem pItem = NULL;
		xr_vector<u16>				ItemsToDelete;

		// 
		TIItemContainer::const_iterator	IBelt = pActor->inventory().m_belt.begin();
		TIItemContainer::const_iterator	EBelt = pActor->inventory().m_belt.end();

		for ( ; IBelt != EBelt; ++IBelt) 
		{
			pItem = (*IBelt);
			CheckItem(ps, pItem, &ItemsDesired, &ItemsToDelete);
		};

		// 
		TISlotArr::const_iterator	ISlot = pActor->inventory().m_slots.begin();
		TISlotArr::const_iterator	ESlot = pActor->inventory().m_slots.end();

		for ( ; ISlot != ESlot; ++ISlot) 
		{
			pItem = (*ISlot).m_pIItem;
			CheckItem(ps, pItem, &ItemsDesired, &ItemsToDelete);
		};
		//-------------------------------------------------------------
		xr_vector<u16>::iterator	IDI = ItemsToDelete.begin();
		xr_vector<u16>::iterator	EDI = ItemsToDelete.end();
		for ( ; IDI != EDI; ++IDI) 
		{
			NET_Packet			P;
			u_EventGen			(P,GE_DESTROY,*IDI);
			Level().Send(P,net_flags(TRUE,TRUE));
		};
		//-------------------------------------------------------------
	};
	//-------------------------------------------------------------
	ps->pItemList.clear();
	for (u32 it = 0; it<ItemsDesired.size(); it++)
	{
		ps->pItemList.push_back(ItemsDesired[it]);
	};
	//-------------------------------------------------------------
	if (!pActor) return;

 	SpawnWeaponsForActor(e_Actor, ps);
};

//void	game_sv_Deathmatch::SpawnWeapon4Actor		(u32 actorId,  LPCSTR N, u8 Addons)
//{
//	if (!N) return;
//	
//	CSE_Abstract			*E	=	spawn_begin	(N);
//	E->ID_Parent = u16(actorId);
//
//	E->s_flags.assign		(M_SPAWN_OBJECT_LOCAL);	// flags
//
//	/////////////////////////////////////////////////////////////////////////////////
//	//   -     
//	CSE_ALifeItemWeapon		*pWeapon	=	smart_cast<CSE_ALifeItemWeapon*>(E);
//	if (pWeapon)
//	{
//		pWeapon->a_elapsed = pWeapon->get_ammo_magsize();
//
//		pWeapon->m_addon_flags.assign(Addons);
//	};
//	/////////////////////////////////////////////////////////////////////////////////
//
//	spawn_end				(E,m_server->GetServer_client()->ID);
//};

BOOL g_bDMIgnore_Money_OnBuy = FALSE;
void	game_sv_Deathmatch::SpawnWeaponsForActor(CSE_Abstract* pE, game_PlayerState*	ps)
{
	CSE_ALifeCreatureActor* pA	=	smart_cast<CSE_ALifeCreatureActor*>(pE);
	R_ASSERT2(pA, "Owner not a Actor");
	if (!pA) return;

	if (!(ps->team < s16(TeamList.size()))) return;

	TEAM_WPN_LIST	WpnList = TeamList[ps->team].aWeapons;
	
	for (u32 i = 0; i<ps->pItemList.size(); i++)
	{
		u16 ItemID = ps->pItemList[i];
//		TEAM_WPN_LIST_it pWpnI	= std::find(WpnList.begin(), WpnList.end(), (ItemID & 0xFF1f));
//		if (pWpnI == WpnList.end() || !((*pWpnI) == (ItemID & 0xFF1f))) continue;
		WeaponDataStruct* pWpnS = NULL;
		if (!GetTeamItem_ByID(&pWpnS, &WpnList, ItemID)) continue;

//		SpawnWeapon4Actor(pA->ID, (*pWpnI).WeaponName.c_str(), u8(ItemID & 0x00FF)>>0x05);
		SpawnWeapon4Actor(pA->ID, pWpnS->WeaponName.c_str(), u8(ItemID & 0x00FF)>>0x05);
		//-------------------------------------------------------------------------------
//		Game().m_WeaponUsageStatistic.OnWeaponBought(ps, (*pWpnI).WeaponName.c_str());
		Game().m_WeaponUsageStatistic.OnWeaponBought(ps, pWpnS->WeaponName.c_str());
	};

	if (!g_bDMIgnore_Money_OnBuy)
		Player_AddMoney(ps, ps->LastBuyAcount);
};

void	game_sv_Deathmatch::LoadWeaponsForTeam		(char* caSection, TEAM_WPN_LIST *pTeamWpnList)
{
	
	R_ASSERT(xr_strcmp(caSection,""));

	pTeamWpnList->clear();

	for (int i = 1; i < UNBUYABLESLOT; ++i)
	{
		//  
		string16			wpnSection;	
		sprintf(wpnSection, "slot%i", i);
		if (!pSettings->line_exist(caSection, wpnSection)) 
		{
//			pTeamWpnList->push_back(wpnOneType);
			continue;
		}

		string1024			wpnNames, wpnSingleName;
		//    
		std::strcpy(wpnNames, pSettings->r_string(caSection, wpnSection));
		u32 count	= _GetItemCount(wpnNames);
		//     ,  ,   
		for (u32 j = 0; j < count; ++j)
		{
			_GetItem(wpnNames, j, wpnSingleName);
			R_ASSERT3(pSettings->line_exist(m_sBaseWeaponCostSection, wpnSingleName), "No base item cost!", wpnSingleName);

			WeaponDataStruct	NewWpnData;

			NewWpnData.SlotItem_ID = (s16(i-1) << 8) | s16(j);
			NewWpnData.WeaponName = wpnSingleName;
			NewWpnData.Cost = pSettings->r_s16(m_sBaseWeaponCostSection, wpnSingleName);
			if (pSettings->line_exist(wpnSingleName, "ammo_class"))
			{
				string1024 wpnAmmos, BaseAmmoName;
				std::strcpy(wpnAmmos, pSettings->r_string(wpnSingleName, "ammo_class"));
				_GetItem(wpnAmmos, 0, BaseAmmoName);
				NewWpnData.WeaponBaseAmmo = BaseAmmoName;
			};

			std::strcat(wpnSingleName, "_cost");
			if (pSettings->line_exist(caSection, wpnSingleName))
				NewWpnData.Cost = pSettings->r_s16(caSection, wpnSingleName);
			
			pTeamWpnList->push_back(NewWpnData);
		}
	}
	//-----------------------------------------------------------
	u32 j=0;
	CInifile::Sect &sect = pSettings->r_section(m_sBaseWeaponCostSection);
	for (CInifile::SectIt it = sect.begin(); it != sect.end(); it++)
	{
		string1024	wpnSingleName;
		std::strcpy(wpnSingleName, (*it).first.c_str());
		WeaponDataStruct* pWpnS = NULL;
		if (GetTeamItem_ByName(&pWpnS, pTeamWpnList, wpnSingleName)) continue;
				
		WeaponDataStruct	NewWpnData;
		NewWpnData.SlotItem_ID = ((s16(UNBUYABLESLOT-1)) << 0x08) | s16(j++);
		NewWpnData.WeaponName = wpnSingleName;
		NewWpnData.Cost = pSettings->r_s16(m_sBaseWeaponCostSection, wpnSingleName);

		pTeamWpnList->push_back(NewWpnData);
	};
};

void	game_sv_Deathmatch::LoadSkinsForTeam		(char* caSection, TEAM_SKINS_NAMES* pTeamSkins)
{
	string256			SkinSingleName;
	string4096			Skins;

	//  strSectionName    
	R_ASSERT(xr_strcmp(caSection,""));

	pTeamSkins->clear();

	//  
	if (!pSettings->line_exist(caSection, "skins")) return;

	//    
	std::strcpy(Skins, pSettings->r_string(caSection, "skins"));
	u32 count	= _GetItemCount(Skins);
	//     ,  ,   
	for (u32 i = 0; i < count; ++i)
	{
		_GetItem(Skins, i, SkinSingleName);
		pTeamSkins->push_back(SkinSingleName);
	};
};


void	game_sv_Deathmatch::LoadDefItemsForTeam	(char* caSection, TEAM_WPN_LIST *pWpnList, DEF_ITEMS_LIST* pDefItems)
{
	string256			ItemName;
	string4096			DefItems;

	//  strSectionName    
	R_ASSERT(xr_strcmp(caSection,""));

	pDefItems->clear();

	//  
	if (!pSettings->line_exist(caSection, "default_items")) return;

	//    
	std::strcpy(DefItems, pSettings->r_string(caSection, "default_items"));
	u32 count	= _GetItemCount(DefItems);
	//     ,  ,   
	for (u32 i = 0; i < count; ++i)
	{
		_GetItem(DefItems, i, ItemName);
//		TEAM_WPN_LIST_it pWpnI	= std::find(pWpnList->begin(), pWpnList->end(), ItemName);
//		if (pWpnI == pWpnList->end() || !((*pWpnI) == ItemName)) continue;
		WeaponDataStruct* pWpnS = NULL;
		if (!GetTeamItem_ByName(&pWpnS, pWpnList, ItemName)) continue;
		
		pDefItems->push_back(pWpnS->SlotItem_ID);
	};
};


void	game_sv_Deathmatch::SetSkin					(CSE_Abstract* E, u16 Team, u16 ID)
{
	if (!E) return;
	//-------------------------------------------
	CSE_Visual* pV = smart_cast<CSE_Visual*>(E);
	if (!pV) return;
	//-------------------------------------------
	string256 SkinName;
	std::strcpy(SkinName, pSettings->r_string("mp_skins_path", "skin_path"));
	//     
//	if (SkinID != -1) ID = u16(SkinID);

	if (!TeamList.empty()	&&
		TeamList.size() > Team	&&
		!TeamList[Team].aSkins.empty())
	{
		//      
		if (TeamList[Team].aSkins.size() > ID)
		{
			std::strcat(SkinName, TeamList[Team].aSkins[ID].c_str());
		}
		else
			std::strcat(SkinName, TeamList[Team].aSkins[0].c_str());
	}
	else
	{
		//     
		switch (Team)
		{
		case 0:
			std::strcat(SkinName, "stalker_hood_multiplayer");
			break;
		case 1:
			std::strcat(SkinName, "soldat_beret");
			break;
		case 2:
			std::strcat(SkinName, "stalker_black_mask");
			break;
		default:
			R_ASSERT2(0,"Unknown Team");
			break;
		};
	};
	std::strcat(SkinName, ".ogf");
	Msg("* Skin - %s", SkinName);
	int len = xr_strlen(SkinName);
	R_ASSERT2(len < 64, "Skin Name is too LONG!!!");
	pV->set_visual(SkinName);
	//-------------------------------------------
};

void	game_sv_Deathmatch::OnPlayerHitPlayer_Case	(game_PlayerState* ps_hitter, game_PlayerState* ps_hitted, SHit* pHitS)
{
	if (ps_hitted->testFlag(GAME_PLAYER_FLAG_INVINCIBLE))
	{
		pHitS->power = 0;
		pHitS->impulse = 0;
	}
};

void	game_sv_Deathmatch::OnPlayerHitPlayer		(u16 id_hitter, u16 id_hitted, NET_Packet& P)
{
	CSE_Abstract*		e_hitter		= get_entity_from_eid	(id_hitter	);
	CSE_Abstract*		e_hitted		= get_entity_from_eid	(id_hitted	);

	if (!e_hitter || !e_hitted) return;
	if (e_hitted->m_tClassID != CLSID_OBJECT_ACTOR) return;

	game_PlayerState*	ps_hitter = get_eid(id_hitter);
	game_PlayerState*	ps_hitted = get_eid(id_hitted);

	if (!ps_hitter || !ps_hitted) return;

	SHit	HitS;
	HitS.Read_Packet(P);

	HitS.whoID	= ps_hitter->GameID;

	OnPlayerHitPlayer_Case(ps_hitter, ps_hitted, &HitS);

	//---------------------------------------
	if (HitS.power > 0)
	{
		ps_hitted->lasthitter = ps_hitter->GameID;
		ps_hitted->lasthitweapon = HitS.weaponID;
	};
	//---------------------------------------
	HitS.Write_Packet(P);
};


void	game_sv_Deathmatch::LoadTeams			()
{
	m_sBaseWeaponCostSection._set("deathmatch_base_cost");
	if (!pSettings->section_exist(m_sBaseWeaponCostSection))
	{
		R_ASSERT2(0, "No section for base weapon cost for this type of the Game!");
		return;
	};

	LoadTeamData("deathmatch_team0");
};

s32		game_sv_Deathmatch::GetMoneyAmount			(char* caSection, char* caMoneyStr)
{
	if (pSettings->line_exist(caSection, caMoneyStr))
		return pSettings->r_s32(caSection, caMoneyStr);

	return 0;
};

void	game_sv_Deathmatch::LoadTeamData			(char* caSection)
{
	TeamStruct	NewTeam;

	NewTeam.caSection	= caSection;

	LoadWeaponsForTeam	(caSection, &NewTeam.aWeapons);
	LoadSkinsForTeam	(caSection, &NewTeam.aSkins);
	LoadDefItemsForTeam	(caSection, &NewTeam.aWeapons, &NewTeam.aDefaultItems);	
	//-------------------------------------------------------------
	if( pSettings->section_exist(caSection) )//money
	{
		NewTeam.m_iM_Start				= GetMoneyAmount(caSection, "money_start");
		NewTeam.m_iM_OnRespawn			= GetMoneyAmount(caSection, "money_respawn");
		NewTeam.m_iM_Min				= GetMoneyAmount(caSection, "money_min");

		NewTeam.m_iM_KillRival			= GetMoneyAmount(caSection, "kill_rival");
		NewTeam.m_iM_KillSelf			= GetMoneyAmount(caSection, "kill_self");
		NewTeam.m_iM_KillTeam			= GetMoneyAmount(caSection, "kill_team");

		NewTeam.m_iM_TargetRival		= GetMoneyAmount(caSection, "target_rival");
		NewTeam.m_iM_TargetTeam			= GetMoneyAmount(caSection, "target_team");
		NewTeam.m_iM_TargetSucceed		= GetMoneyAmount(caSection, "target_succeed");
		NewTeam.m_iM_TargetSucceedAll	= GetMoneyAmount(caSection, "target_succeed_all");
		NewTeam.m_iM_TargetFailed		= GetMoneyAmount(caSection, "target_failed");

		NewTeam.m_iM_RoundWin			= GetMoneyAmount(caSection, "round_win");
		NewTeam.m_iM_RoundLoose			= GetMoneyAmount(caSection, "round_loose");
		NewTeam.m_iM_RoundDraw			= GetMoneyAmount(caSection, "round_draw");

		NewTeam.m_iM_RoundWin_Minor		= GetMoneyAmount(caSection, "round_win_minor");
		NewTeam.m_iM_RoundLoose_Minor	= GetMoneyAmount(caSection, "round_loose_minor");

		NewTeam.m_iM_RivalsWipedOut		= GetMoneyAmount(caSection, "rivals_wiped_out");

		NewTeam.m_iM_ClearRunBonus		= GetMoneyAmount(caSection, "clear_run_bonus");
		//---------------------------------------------------------------------------
		if (pSettings->line_exist(caSection, "kill_while_invincible"))
			NewTeam.m_fInvinsibleKillModifier = pSettings->r_float(caSection, "kill_while_invincible");
		else
			NewTeam.m_fInvinsibleKillModifier = 0.5f;
	};
	//-------------------------------------------------------------
	TeamList.push_back(NewTeam);
};

void game_sv_Deathmatch::OnDestroyObject			(u16 eid_who)
{
	if (eid_who == m_dwSM_CurViewEntity && m_bSpectatorMode)
	{
		SM_SwitchOnNextActivePlayer();
	};

	for (u32 i=0; i<m_CorpseList.size();)
	{
		if (m_CorpseList[i] == eid_who)
		{
			m_CorpseList.erase(m_CorpseList.begin()+i);
		}
		else i++;
	};

	CSE_Abstract* entity = get_entity_from_eid(eid_who);
	if (entity && entity->owner->ps->GameID == eid_who)
	{
		xrClientData* xrCData = entity->owner;
//		game_PlayerState* ps = entity->owner->ps;
		if (Phase() == GAME_PHASE_INPROGRESS)
		{		
			CSE_ALifeCreatureActor*			A		= smart_cast<CSE_ALifeCreatureActor*> (entity);
			if (A)
			{
				SpawnPlayer(xrCData->ID, "spectator");
			}
		};
	}
};



void game_sv_Deathmatch::Money_SetStart			(ClientID	id_who)
{
	game_PlayerState*	ps_who	=	get_id	(id_who);
	if (!ps_who) return;
	ps_who->money_for_round = 0;
	if (ps_who->team < 0) return;
	TeamStruct*	pTeamData = GetTeamData(u8(ps_who->team));
	if (!pTeamData) return;
	ps_who->money_for_round = pTeamData->m_iM_Start;
}

void	game_sv_Deathmatch::RemoveItemFromActor	(CSE_Abstract* pItem)
{
	if (!pItem) return;
	//-------------------------------------------------------------
	CSE_ALifeItemWeapon* pWeapon = smart_cast<CSE_ALifeItemWeapon*> (pItem);
	if (pWeapon)
	{
	};
	//-------------------------------------------------------------
	NET_Packet			P;
	u_EventGen			(P,GE_DESTROY,pItem->ID);
	Level().Send(P,net_flags(TRUE,TRUE));
};

void	game_sv_Deathmatch::OnTeamScore	(u32 Team, bool Minor)
{
	TeamStruct* pTeam		= GetTeamData(u8(Team));
	if (!pTeam) return;
	
	u32		cnt = get_players_count();
	for		(u32 it=0; it<cnt; ++it)	
	{
		// init
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!l_pC->net_Ready) continue;
		if (ps->Skip) continue;		

		if (ps->team == s16(Team))
			Player_AddMoney(ps, ((Minor) ? pTeam->m_iM_RoundWin_Minor : pTeam->m_iM_RoundWin));
		else
			Player_AddMoney(ps, ((Minor) ? pTeam->m_iM_RoundLoose_Minor : pTeam->m_iM_RoundLoose));
	}
}


void game_sv_Deathmatch::net_Export_State		(NET_Packet& P, ClientID id_to)
{
	inherited::net_Export_State(P, id_to);

	P.w_s32			(fraglimit);
	P.w_s32			(timelimit);
//	P.w_u32			(damageblocklimit);
	P.w_u32			(m_u32ForceRespawn);
	P.w_u32			(m_dwWarmUp_CurTime);
	P.w_u8			(u8(m_bDamageBlockIndicators));
	// Teams
	P.w_u16			(u16(teams.size()));
	for (u32 t_it=0; t_it<teams.size(); ++t_it)
	{
		P.w				(&teams[t_it],sizeof(game_TeamState));
	}
	switch(Phase())
	{
	case GAME_PHASE_PLAYER_SCORES:
		{
			P.w_stringZ(pWinnigPlayerName);
		}break;
	}
}

int game_sv_Deathmatch::GetTeamScore(u32 idx)
{
	VERIFY( (idx>=0) && (idx<teams.size()) );
	return teams[idx].score;
}

void game_sv_Deathmatch::OnPlayerSelectSkin		(NET_Packet& P, ClientID sender)
{
	xrClientData *l_pC = m_server->ID_to_client(sender);
	s8 l_skin;
	P.r_s8(l_skin);
	OnPlayerChangeSkin(l_pC->ID, l_skin);
	//---------------------------------------
	signal_Syncronize();
	//---------------------------------------
	NET_Packet Px;
	GenerateGameMessage(Px);
	Px.w_u32(GAME_EVENT_PLAYER_GAME_MENU_RESPOND);
	Px.w_u8(PLAYER_CHANGE_SKIN);
	Px.w_s8(l_pC->ps->skin);
	m_server->SendTo(sender,Px,net_flags(TRUE,TRUE));
};

void game_sv_Deathmatch::OnPlayerChangeSkin(ClientID id_who, s8 skin) 
{
	game_PlayerState*	ps_who	=	get_id	(id_who);
	if (!ps_who) return;
	ps_who->skin = skin;
	ps_who->resetFlag(GAME_PLAYER_FLAG_SPECTATOR);
	if (skin == -1)
	{
		ps_who->skin = u8(::Random.randI((int)TeamList[ps_who->team].aSkins.size()));
	}

	KillPlayer(id_who, ps_who->GameID);
}

void game_sv_Deathmatch::SetTeamScore(u32 idx, int val)
{
	VERIFY( (idx>=0) && (idx<teams.size()) );
	teams[idx].score = val;
}


void	game_sv_Deathmatch::LoadAnomalySets			()
{	
	//-----------------------------------------------------------
	m_AnomalySetsList.clear();
	m_AnomaliesPermanent.clear();
	//-----------------------------------------------------------
	if (!m_AnomalyIDSetsList.empty())
	{
		for (u32 i=0; i<m_AnomalyIDSetsList.size(); i++)
		{
			m_AnomalyIDSetsList[i].clear();
		};
		m_AnomalyIDSetsList.clear();
	};
	//-----------------------------------------------------------
	if (!g_pGameLevel || !Level().pLevel) return;

	char* ASetBaseName = GetAnomalySetBaseName();

	string1024 SetName, AnomaliesNames, AnomalyName;
	ANOMALIES		AnomalySingleSet;
	ANOMALIES_ID	AnomalyIDSingleSet;
	for (u32 i=0; i<20; i++)
	{
		AnomalySingleSet.clear();
		AnomalyIDSingleSet.clear();

		sprintf(SetName, "set%i", i);		
		if (!Level().pLevel->line_exist(ASetBaseName, SetName))
			continue;

		std::strcpy(AnomaliesNames, Level().pLevel->r_string(ASetBaseName, SetName));
		u32 count	= _GetItemCount(AnomaliesNames);
		if (!count) continue;

		for (u32 j=0; j<count; j++)
		{
			_GetItem(AnomaliesNames, j, AnomalyName);
			AnomalySingleSet.push_back(AnomalyName);
		};

		if (AnomalySingleSet.empty()) continue;
		m_AnomalySetsList.push_back(AnomalySingleSet);
		m_AnomalyIDSetsList.push_back(AnomalyIDSingleSet);
	};
	//---------------------------------------------------------
	if (Level().pLevel->line_exist(ASetBaseName, "permanent"))
	{
		std::strcpy(AnomaliesNames, Level().pLevel->r_string(ASetBaseName, "permanent"));
		u32 count	= _GetItemCount(AnomaliesNames);
		for (u32 j=0; j<count; j++)
		{
			_GetItem(AnomaliesNames, j, AnomalyName);
			m_AnomaliesPermanent.push_back(AnomalyName);
		};
	}
};

void	game_sv_Deathmatch::Send_EventPack_for_AnomalySet	(u32 AnomalySet, u8 Event)
{
	if (m_AnomalyIDSetsList.size() <= AnomalySet) return;
	//-----------------------------------
	NET_Packet	EventPack;
	EventPack.w_begin	(M_EVENT_PACK);
	//-----------------------------------
	ANOMALIES_ID* Anomalies = &(m_AnomalyIDSetsList[AnomalySet]);
	if (Anomalies->empty()) return;
	for (u32 i=0; i<Anomalies->size(); i++)
	{
		u16 ID = (*Anomalies)[i];
		//-----------------------------------
		NET_Packet P;
		u_EventGen		(P,GE_ZONE_STATE_CHANGE,ID);
		P.w_u8			(u8(Event)); //eZoneStateDisabled
		//-----------------------------------
		EventPack.w_u8(u8(P.B.count));
		EventPack.w(&P.B.data, P.B.count);
	};
	u_EventSend(EventPack);
};

void	game_sv_Deathmatch::StartAnomalies			(int AnomalySet)
{	
	if (m_AnomalySetsList.empty()) return;	

	if (AnomalySet != -1 && u32(AnomalySet) >= m_AnomalySetsList.size())
		return;

	xr_vector<u8>&	ASetID	= m_AnomalySetID;
	if (ASetID.empty())
	{
		u8 Size = (u8)m_AnomalySetsList.size();
		for (u8 i=0; i<Size; i++)
		{
			if (m_dwLastAnomalySetID == i && Size > 1) continue;
			ASetID.push_back(i);
		};
	};

	u8 ID = u8(::Random.randI((int)ASetID.size()));
	u32 NewAnomalySetID = ASetID[ID];
	ASetID.erase(ASetID.begin()+ID);
	///////////////////////////////////////////////////
	if (m_dwLastAnomalySetID < m_AnomalySetsList.size())
	{
		Send_EventPack_for_AnomalySet(m_dwLastAnomalySetID, CCustomZone::eZoneStateDisabled); //Disable
		/*
		ANOMALIES* OldAnomalies = &(m_AnomalySetsList[m_dwLastAnomalySetID]);
		for (u32 i=0; i<OldAnomalies->size(); i++)
		{
			const char *pName = ((*OldAnomalies)[i]).c_str();
			CCustomZone* pZone = smart_cast<CCustomZone*> (Level().Objects.FindObjectByName(pName));
			if (!pZone) continue;
//			if (pZone->IsEnabled())
				pZone->ZoneDisable();
		};
		*/
	};
	///////////////////////////////////////////////////
	if (AnomalySet != -1 && AnomalySet < (int)m_AnomalySetsList.size())
	{
		m_dwLastAnomalySetID = u32(AnomalySet);
		m_AnomalySetID.clear();
	}
	else
		m_dwLastAnomalySetID = NewAnomalySetID;

	if (m_bAnomaliesEnabled)
		Send_EventPack_for_AnomalySet(m_dwLastAnomalySetID, CCustomZone::eZoneStateIdle); //Idle
	/*
	ANOMALIES* NewAnomalies = &(m_AnomalySetsList[m_dwLastAnomalySetID]);
	for (u32 i=0; i<NewAnomalies->size(); i++)
	{
		const char *pName = ((*NewAnomalies)[i]).c_str();
		CCustomZone* pZone = smart_cast<CCustomZone*> (Level().Objects.FindObjectByName(pName));
		if (!pZone) continue;
//		if (!pZone->IsEnabled())
			pZone->ZoneEnable();
	};
	*/
	m_dwLastAnomalyStartTime = Level().timeServer();
#ifdef DEBUG
	Msg("Anomaly Set %d Activated", m_dwLastAnomalySetID);
#endif
};

BOOL	game_sv_Deathmatch::OnTouch			(u16 eid_who, u16 eid_what)
{
	CSE_Abstract*		e_who	= m_server->ID_to_entity(eid_who);		VERIFY(e_who	);
	CSE_Abstract*		e_what	= m_server->ID_to_entity(eid_what);	VERIFY(e_what	);

	CSE_ALifeCreatureActor*			A		= smart_cast<CSE_ALifeCreatureActor*> (e_who);
	if (A)
	{
		// Actor touches something
		CSE_ALifeItemWeapon*	W			=	smart_cast<CSE_ALifeItemWeapon*> (e_what);
		if (W) 
		{
			// Weapon
			xr_vector<u16>&	C			=	A->children;
			u8 slot						=	W->get_slot	();
			for (u32 it=0; it<C.size(); ++it)
			{
				CSE_Abstract*		Et	= m_server->ID_to_entity				(C[it]);
				if (0==Et)				continue;
				CSE_ALifeItemWeapon*		T	= smart_cast<CSE_ALifeItemWeapon*>	(Et);
				if (0==T)				continue;
				if (slot == T->get_slot())	
				{
/*					// We've found same slot occupied - disallow ownership
					//-----------------------------------------------------
					NET_Packet				P;
					u_EventGen				(P,GE_OWNERSHIP_REJECT,eid_who);
					P.w_u16					(T->ID);
					Level().Send(P,net_flags(TRUE,TRUE));
					//-----------------------------------------------------
					u_EventGen				(P,GE_OWNERSHIP_TAKE,eid_who);
					P.w_u16					(eid_what);
					Level().Send(P,net_flags(TRUE,TRUE));
					//-----------------------------------------------------
*/					return FALSE;
				}
			}

			// Weapon slot empty - ownership OK
			return TRUE;
		}
		
		CSE_ALifeItemAmmo* pIAmmo			=	smart_cast<CSE_ALifeItemAmmo*> (e_what);
		if (pIAmmo)
		{
			//Ammo
			return TRUE;
		};

		CSE_ALifeItemGrenade* pIGrenade		=	smart_cast<CSE_ALifeItemGrenade*> (e_what);
		if (pIGrenade)
		{
			//Grenade
			return TRUE;
		};

		CSE_ALifeItemCustomOutfit* pOutfit		= smart_cast<CSE_ALifeItemCustomOutfit*> (e_what);
		if (pOutfit)
		{
			//Possibly Addons and/or Outfits
			return TRUE;
		};

		//---------------------------------------------------------------
		if (e_what->m_tClassID == CLSID_OBJECT_PLAYERS_BAG)
		{
			if (e_what->ID_Parent == 0xffff)
			{
				//-------------------------------
				//move all items from rukzak to player
				if (!e_what->children.empty())
				{
					NET_Packet	EventPack, PacketReject, PacketTake;
					EventPack.w_begin	(M_EVENT_PACK);

					while (!e_what->children.empty())
					{
						CSE_Abstract		*e_child_item = get_entity_from_eid(e_what->children.back());
						m_server->Perform_transfer(PacketReject, PacketTake, e_child_item, e_what, e_who);

						EventPack.w_u8(u8(PacketReject.B.count));
						EventPack.w(&PacketReject.B.data, PacketReject.B.count);
						EventPack.w_u8(u8(PacketTake.B.count));
						EventPack.w(&PacketTake.B.data, PacketTake.B.count);
					}
					if (EventPack.B.count > 2)	u_EventSend(EventPack);
				}
				//-------------------------------
				NET_Packet		P;
				u_EventGen		(P,GE_DESTROY,e_what->ID);
				m_server->OnMessage(P, m_server->GetServerClient()->ID);
				//-------------------------------
				game_PlayerState* pKiller = get_eid(eid_who);
				if (pKiller)
				{
					if (m_bPDAHunt)
					{
						Player_AddBonusMoney(pKiller, READ_IF_EXISTS(pSettings, r_s32, "mp_bonus_money", "pda_taken",0), SKT_PDA);
					};
				};
				//-------------------------------
				return FALSE;
			}
		};
		//---------------------------------------------------------------
		if (IsBuyableItem(*e_what->s_name)) return TRUE;
		//---------------------------------------------------------------
		/*
		if (e_what->m_tClassID == CLSID_DEVICE_PDA) 
		{
			if (e_what->ID_Parent == 0xffff)
			{			
				//-------------------------------
				NET_Packet		P;
				u_EventGen		(P,GE_DESTROY,e_what->ID);
				m_server->OnMessage(P, m_server->GetServerClient()->ID);
				//-------------------------------
				game_PlayerState* pKiller = get_eid(eid_who);
				if (pKiller)
				{
					if (m_bPDAHunt)
					{
						Player_AddBonusMoney(pKiller, READ_IF_EXISTS(pSettings, r_s32, "mp_bonus_money", "pda_taken",0), SKT_PDA);
					};
				};
				//-------------------------------
				return FALSE;
			};
			return TRUE;
		};
		*/
	};
	// We don't know what the hell is it, so disallow ownership just for safety 
	return FALSE;
}

BOOL	game_sv_Deathmatch::OnDetach		(u16 eid_who, u16 eid_what)
{	
	CSE_Abstract*		e_parent	= get_entity_from_eid	(eid_who);
	CSE_Abstract*		e_entity	= get_entity_from_eid	(eid_what);
	if (!e_parent || !e_entity)
		return			(TRUE);

	if (e_entity->m_tClassID == CLSID_OBJECT_PLAYERS_BAG && e_parent->m_tClassID == CLSID_OBJECT_ACTOR)
	{
		NET_Packet	EventPack, PacketReject, PacketTake;
		EventPack.w_begin	(M_EVENT_PACK);
		
		//move all items from player to rukzak
		for (u32 i=0; i<e_parent->children.size();)
		{
			u16 ItemID = e_parent->children[i];
			CSE_Abstract* e_item = get_entity_from_eid(ItemID);
			R_ASSERT(e_item->ID_Parent == e_parent->ID);

			switch (e_item->m_tClassID)
			{
			case CLSID_OBJECT_A_FN2000			:
			case CLSID_OBJECT_A_AK74			:
			case CLSID_OBJECT_A_LR300			:
			case CLSID_OBJECT_A_HPSA			:
			case CLSID_OBJECT_A_PM				:
			case CLSID_OBJECT_A_FORT			:
				//---------------------------------------
			case CLSID_OBJECT_A_VOG25			:
			case CLSID_OBJECT_A_OG7B			:
			case CLSID_OBJECT_A_M209			:
				//---------------------------------------
				// Weapons Add-ons
			case CLSID_OBJECT_W_SCOPE			:
			case CLSID_OBJECT_W_SILENCER		:
			case CLSID_OBJECT_W_GLAUNCHER		:
				// Detectors
			case CLSID_DETECTOR_SIMPLE		:
				// PDA
			case CLSID_DEVICE_PDA			:

			case CLSID_DEVICE_TORCH			:
			case CLSID_IITEM_MEDKIT			:
			case CLSID_IITEM_ANTIRAD		:
				// Grenades
			case CLSID_GRENADE_F1			:
			case CLSID_OBJECT_G_RPG7		:
			case CLSID_GRENADE_RGD5			:
				// Weapons
			case CLSID_OBJECT_W_M134			:
			case CLSID_OBJECT_W_FN2000		:
			case CLSID_OBJECT_W_AK74			:
			case CLSID_OBJECT_W_LR300		:
			case CLSID_OBJECT_W_HPSA			:
			case CLSID_OBJECT_W_PM			:
			case CLSID_OBJECT_W_FORT			:
			case CLSID_OBJECT_W_BINOCULAR	:
			case CLSID_OBJECT_W_SHOTGUN		:
			case CLSID_OBJECT_W_SVD			:
			case CLSID_OBJECT_W_SVU			:
			case CLSID_OBJECT_W_RPG7			:
			case CLSID_OBJECT_W_VAL			:
			case CLSID_OBJECT_W_VINTOREZ		:
			case CLSID_OBJECT_W_WALTHER		:
			case CLSID_OBJECT_W_USP45		:
			case CLSID_OBJECT_W_GROZA		:
			case CLSID_OBJECT_W_BM16			:
			case CLSID_OBJECT_W_RG6			:
				{
				}break;
			default:
				{
					i++;
					continue;
				}break;
			};
			m_server->Perform_transfer(PacketReject, PacketTake, e_item, e_parent, e_entity);
			EventPack.w_u8(u8(PacketReject.B.count));
			EventPack.w(&PacketReject.B.data, PacketReject.B.count);
			EventPack.w_u8(u8(PacketTake.B.count));
			EventPack.w(&PacketTake.B.data, PacketTake.B.count);

			/*
			NET_Packet	P;
			u32			time		= Device.dwTimeGlobal;
			//remove item from actor
			xr_vector<u16>& C	= e_parent->children;
			xr_vector<u16>::iterator c	= std::find	(C.begin(),C.end(),ItemID);
			VERIFY3				(C.end()!=c,e_entity->name_replace(),e_parent->name_replace());
			C.erase				(c);
			//---------------------------------------------
			P.w_begin				(M_EVENT);
			P.w_u32					(time);
			P.w_u16					(GE_OWNERSHIP_REJECT);
			P.w_u16					(e_parent->ID);
			P.w_u16					(ItemID);
			//---------------------------------------------
			EventPack.w_u8(u8(P.B.count));
			EventPack.w(&P.B.data, P.B.count);
			//---------------------------------------------
			//move item to rukzak
			e_item->ID_Parent = e_entity->ID;
			e_entity->children.push_back(ItemID);
			//---------------------------------------------
			P.w_begin				(M_EVENT);
			P.w_u32					(time);
			P.w_u16					(GE_OWNERSHIP_TAKE);
			P.w_u16					(e_entity->ID);
			P.w_u16					(ItemID);
			//---------------------------------------------
			EventPack.w_u8(u8(P.B.count));
			EventPack.w(&P.B.data, P.B.count);
			//---------------------------------------------
			*/			
		}
		if (EventPack.B.count > 2)	u_EventSend(EventPack);
	};
	return TRUE;
}

void game_sv_Deathmatch::OnPlayerConnect	(ClientID id_who)
{
	inherited::OnPlayerConnect	(id_who);

	xrClientData* xrCData	=	m_server->ID_to_client(id_who);
	game_PlayerState*	ps_who	=	get_id	(id_who);

	if (!xrCData->flags.bReconnect)
	{
		ps_who->clear();
		ps_who->team				=	0;	
		ps_who->skin				=	-1;
	};
	ps_who->setFlag(GAME_PLAYER_FLAG_SPECTATOR);
	
	ps_who->Skip = false;
	SpawnPlayer(id_who, "spectator");

	if (g_pGamePersistent->bDedicatedServer && (xrCData == m_server->GetServerClient()) )
	{
		ps_who->Skip = true;
		return;
	}

	if (!xrCData->flags.bReconnect)
	{
		Money_SetStart(id_who);
		SetPlayersDefItems(ps_who);
	};
}

void	game_sv_Deathmatch::OnPlayerConnectFinished	(ClientID id_who)
{
	xrClientData* xrCData	=	m_server->ID_to_client(id_who);
	// Send Message About Client Connected
	if (xrCData)
	{
		NET_Packet			P;
		GenerateGameMessage (P);
		P.w_u32				(GAME_EVENT_PLAYER_CONNECTED);
		P.w_stringZ			(get_option_s(*xrCData->Name,"name",*xrCData->Name));

		u_EventSend(P);
	};
	Send_Anomaly_States(id_who);
};

void	game_sv_Deathmatch::check_Player_for_Invincibility	(game_PlayerState* ps)
{
	if (!ps) return;
	u32 CurTime = Device.dwTimeGlobal;
	if ((ps->RespawnTime + damageblocklimit < CurTime) && ps->testFlag(GAME_PLAYER_FLAG_INVINCIBLE))
	{
		ps->resetFlag(GAME_PLAYER_FLAG_INVINCIBLE);
	}
};

void	game_sv_Deathmatch::check_InvinciblePlayers()
{
	u32		cnt		= get_players_count	();
	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (ps->testFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD)) continue;
		u16 OldFlags = ps->flags;
		check_Player_for_Invincibility(ps);
		if (ps->flags != OldFlags) signal_Syncronize();
	};
};

void	game_sv_Deathmatch::RespawnPlayer			(ClientID id_who, bool NoSpectator)
{
	inherited::RespawnPlayer(id_who, NoSpectator);

	xrClientData*	xrCData	= (xrClientData*)m_server->ID_to_client	(id_who);
	game_PlayerState*	ps	=	xrCData->ps;
	CSE_Abstract*	pOwner = xrCData->owner;
	CSE_ALifeCreatureActor	*pA	=	smart_cast<CSE_ALifeCreatureActor*>(pOwner);
	if(!pA) return;

	TeamStruct*	pTeamData = GetTeamData(u8(ps->team));
	if (pTeamData)
		Player_AddMoney(ps, pTeamData->m_iM_OnRespawn);

	if (damageblocklimit > 0)
		ps->setFlag(GAME_PLAYER_FLAG_INVINCIBLE);
	//------------------------------------------------------	
//	if (m_bPDAHunt) SpawnWeapon4Actor(pA->ID, "device_pda", 0);
	//-----------------------------------------------------
	SpawnWeapon4Actor(pA->ID, "mp_players_rukzak", 0);
}

INT		G_DELAYED_ROUND_TIME	= 7000;
void	game_sv_Deathmatch::OnDelayedRoundEnd		(LPCSTR /**reason/**/)
{
	m_delayedRoundEnd = true;
	m_roundEndDelay = Device.TimerAsync() + G_DELAYED_ROUND_TIME;
}

void	game_sv_Deathmatch::check_ForceRespawn		()
{
	if (!m_u32ForceRespawn) return;
	u32		cnt		= get_players_count	();
	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!l_pC->net_Ready || ps->Skip) continue;
		if (!ps->testFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD)) continue;
		if (ps->testFlag(GAME_PLAYER_FLAG_SPECTATOR)) continue;
		u32 CurTime = Device.dwTimeGlobal;
		if (ps->DeathTime + m_u32ForceRespawn < CurTime)
		{
			SetPlayersDefItems(ps);
			RespawnPlayer(l_pC->ID, true);
			SpawnWeaponsForActor(l_pC->owner, ps);
			Check_ForClearRun(ps);
		}
	};
};

INT	g_sv_Skip_Winner_Waiting = 0;
bool	game_sv_Deathmatch::HasChampion()
{
	game_PlayerState* res = NULL;
	s16 MaxFrags	= -1;

	u32		cnt		= get_players_count	();
	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!ps) continue;
		if (ps->kills > MaxFrags)
		{
			MaxFrags = ps->kills;
			res = ps;
		}
	};

	for		(u32 it=0; it<cnt; ++it)	
	{
		xrClientData *l_pC = (xrClientData*)	m_server->client_Get	(it);
		game_PlayerState* ps	= l_pC->ps;
		if (!ps) continue;
		if (ps->kills == MaxFrags && ps != res)
		{
			return false;
		}
	};

	return (MaxFrags>0 || g_sv_Skip_Winner_Waiting);
};

bool	game_sv_Deathmatch::check_for_Anomalies()
{
	if (!m_bAnomaliesEnabled) return false;

	if (m_dwLastAnomalySetID < 1000)
	{
		if (m_dwLastAnomalyStartTime + m_dwAnomalySetLengthTime > Level().timeServer()) return false;
	};
	StartAnomalies(); 
	return true;
}

BOOL	game_sv_Deathmatch::Is_Anomaly_InLists		(CSE_Abstract* E)
{
	if (!E) return FALSE;
	
	ANOMALIES_it It = std::find(m_AnomaliesPermanent.begin(), m_AnomaliesPermanent.end(),E->name_replace());
	if (It != m_AnomaliesPermanent.end())
	{
		return TRUE;
	};

	for (u32 j=0; j<m_AnomalySetsList.size(); j++)
	{
		ANOMALIES* Anomalies = &(m_AnomalySetsList[j]);
		ANOMALIES_it It = std::find(Anomalies->begin(), Anomalies->end(),E->name_replace());
		if (It != Anomalies->end())
		{
			return TRUE;
		};
	};
	return FALSE;
}

BOOL	game_sv_Deathmatch::OnPreCreate				(CSE_Abstract* E)
{
	BOOL res = inherited::OnPreCreate(E);
	if (!res) return res;

	CSE_ALifeCustomZone* pCustomZone	=	smart_cast<CSE_ALifeCustomZone*> (E);
	if (pCustomZone)
	{
		return Is_Anomaly_InLists(pCustomZone);
	}

	return TRUE;
};

void game_sv_Deathmatch::OnCreate				(u16 eid_who)
{
	inherited::OnCreate(eid_who);

	CSE_Abstract	*pEntity	= get_entity_from_eid(eid_who);
	if (!pEntity) return;
	CSE_ALifeCustomZone* pCustomZone	=	smart_cast<CSE_ALifeCustomZone*> (pEntity);
	if (pCustomZone) 
	{
		pCustomZone->m_maxPower = pSettings->r_float(*pCustomZone->s_name,"max_start_power");
	}
};

void game_sv_Deathmatch::OnPostCreate				(u16 eid_who)
{
	inherited::OnPostCreate(eid_who);

	CSE_Abstract	*pEntity	= get_entity_from_eid(eid_who);
	if (!pEntity) return;
	CSE_ALifeCustomZone* pCustomZone	=	smart_cast<CSE_ALifeCustomZone*> (pEntity);
	if (!pCustomZone || pCustomZone->m_owner_id != u32(-1)) return;
	
	for (u32 j=0; j<m_AnomalySetsList.size(); j++)
	{
		ANOMALIES* Anomalies = &(m_AnomalySetsList[j]);
		ANOMALIES_it It = std::find(Anomalies->begin(), Anomalies->end(),pCustomZone->name_replace());
		if (It != Anomalies->end())
		{
			m_AnomalyIDSetsList[j].push_back(eid_who);

			//-----------------------------------------------------------------------------
			NET_Packet P;
			u_EventGen		(P,GE_ZONE_STATE_CHANGE,eid_who);
			P.w_u8			(u8(CCustomZone::eZoneStateDisabled)); //eZoneStateDisabled
			u_EventSend(P);
			//-----------------------------------------------------------------------------
			return;
		};
	};
	
	ANOMALIES_it It = std::find(m_AnomaliesPermanent.begin(), m_AnomaliesPermanent.end(),pCustomZone->name_replace());
	if (It == m_AnomaliesPermanent.end())
	{
		Msg("! Anomaly Not Found in any Set : %s", pCustomZone->name_replace());

		NET_Packet P;
		u_EventGen		(P,GE_ZONE_STATE_CHANGE,eid_who);
		P.w_u8			(u8(CCustomZone::eZoneStateDisabled)); //eZoneStateDisabled
		u_EventSend(P);
	};
};

void	game_sv_Deathmatch::Send_Anomaly_States		(ClientID id_who)
{
	if (m_AnomalyIDSetsList.empty()) return;
	//-----------------------------------
	NET_Packet	EventPack;
	EventPack.w_begin	(M_EVENT_PACK);
	//-----------------------------------
	for (u32 j=0; j<m_AnomalyIDSetsList.size(); j++)
	{
		u8 AnomalyState = u8((m_dwLastAnomalySetID == j) ? CCustomZone::eZoneStateIdle : CCustomZone::eZoneStateDisabled);

		ANOMALIES_ID* Anomalies = &(m_AnomalyIDSetsList[j]);
		if (Anomalies->empty()) return;
		for (u32 i=0; i<Anomalies->size(); i++)
		{
			u16 ID = (*Anomalies)[i];
			//-----------------------------------
			NET_Packet P;
			u_EventGen		(P,GE_ZONE_STATE_CHANGE,ID);
			
			P.w_u8			(u8(AnomalyState));
			//-----------------------------------
			EventPack.w_u8(u8(P.B.count));
			EventPack.w(&P.B.data, P.B.count);
		};
	};
//	u_EventSend(EventPack);
	m_server->SendTo(id_who, EventPack, net_flags(TRUE, TRUE));
};

void	game_sv_Deathmatch::Check_ForClearRun		(game_PlayerState* ps)
{
	if (!ps) return;
	if (ps->LastBuyAcount != 0) return;
	TeamStruct* pTeam		= GetTeamData(u8(ps->team));
	if (!pTeam) return;	
	
	Player_AddMoney(ps, pTeam->m_iM_ClearRunBonus);	
};

//---------------------------------------------------------------------
void	game_sv_Deathmatch::ReadOptions				(shared_str &options)
{
	inherited::ReadOptions(options);
	//-------------------------------
	m_u32ForceRespawn	= get_option_i		(*options, "frcrspwn", 0) * 1000;
	fraglimit			= get_option_i		(*options,"fraglimit",0);
	timelimit			= get_option_i		(*options,"timelimit",0)*60000;	// in (ms)
	damageblocklimit	= get_option_i		(*options,"dmgblock",0)*1000;	// in (ms)
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	m_bDamageBlockIndicators = (get_option_i(*options,"dmbi",0) != 0);
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	m_bAnomaliesEnabled = (get_option_i(*options,"ans",1) != 0);
	m_dwAnomalySetLengthTime = get_option_i(*options, "anslen", 60)*60000; //in (ms)
	//-----------------------------------------------------------------------
	m_bSpectatorMode = false;
	if (!g_pGamePersistent->bDedicatedServer && (get_option_i(*options,"spectr",-1) != -1))
	{
		m_bSpectatorMode = true;
		m_dwSM_SwitchDelta =  get_option_i(*options,"spectr",0)*1000;
		if (m_dwSM_SwitchDelta<1000) m_dwSM_SwitchDelta = 1000;
	};
	//-------------------------------------------------------------------------
	m_dwWarmUp_MaxTime	= get_option_i		(*options,"warmup",0) * 1000;
};



static bool g_bConsoleCommandsCreated_DM = false;
void game_sv_Deathmatch::ConsoleCommands_Create	()
{
	inherited::ConsoleCommands_Create();
	//-------------------------------------
	string1024 Cmnd;
	//-------------------------------------	
	CMD_ADD(CCC_SV_Int,"sv_forcerespawn", (int*)&m_u32ForceRespawn,0,60000,g_bConsoleCommandsCreated_DM,Cmnd);
	CMD_ADD(CCC_SV_Int,"sv_fraglimit", &fraglimit, 0,100,g_bConsoleCommandsCreated_DM,Cmnd);
	CMD_ADD(CCC_SV_Int,"sv_timelimit", &timelimit, 0,3600000,g_bConsoleCommandsCreated_DM,Cmnd);
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_ADD(CCC_SV_Int,"sv_dmgblockindicator", (int*)&m_bDamageBlockIndicators, 0, 1,g_bConsoleCommandsCreated_DM,Cmnd);
	CMD_ADD(CCC_SV_Int,"sv_dmgblocktime", (int*)&damageblocklimit, 0, 300000,g_bConsoleCommandsCreated_DM,Cmnd);
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_ADD(CCC_SV_Int,"sv_anomalies_enabled", (int*)&m_bAnomaliesEnabled, 0, 1,g_bConsoleCommandsCreated_DM,Cmnd);
	CMD_ADD(CCC_SV_Int,"sv_anomalies_length", (int*)&m_dwAnomalySetLengthTime, 0, 3600000,g_bConsoleCommandsCreated_DM,Cmnd);
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_ADD(CCC_SV_Int,"sv_pda_hunt", (int*)&m_bPDAHunt, 0, 1,g_bConsoleCommandsCreated_DM,Cmnd);
	//-------------------------------------
	CMD_ADD(CCC_SV_Int,"sv_warm_up", (int*)&m_dwWarmUp_MaxTime, 0, 3600000,g_bConsoleCommandsCreated_DM,Cmnd);
	//-------------------------------------
	CMD_ADD(CCC_SV_Int,"sv_ignore_money_on_buy", (int*)&g_bDMIgnore_Money_OnBuy, 0, 1,g_bConsoleCommandsCreated_DM,Cmnd);
	//-------------------------------------
	g_bConsoleCommandsCreated_DM = true;
};

void game_sv_Deathmatch::ConsoleCommands_Clear	()
{
	inherited::ConsoleCommands_Clear();
	//-----------------------------------
	CMD_CLEAR("sv_forcerespawn");
	CMD_CLEAR("sv_fraglimit");
	CMD_CLEAR("sv_timelimit");
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_CLEAR("sv_dmgblockindicator");
	CMD_CLEAR("sv_dmgblocktime");
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_CLEAR("sv_anomalies_enabled");
	CMD_CLEAR("sv_anomalies_length");
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	CMD_CLEAR("sv_warm_up");
};
//-----------------------------------------------------------------------------
void game_sv_Deathmatch::OnPlayerFire (ClientID id_who, NET_Packet &P)
{
	u16 PlayerID = P.r_u16();
	game_PlayerState*	ps	=	get_eid	(PlayerID);
	if (!ps || ps->Skip) return;
	if (ps->testFlag(GAME_PLAYER_FLAG_INVINCIBLE))
	{
		ps->resetFlag(GAME_PLAYER_FLAG_INVINCIBLE);
		signal_Syncronize();
	};
};

//  [7/5/2005]
#ifdef DEBUG
xr_vector<u32> xPath;
void game_sv_Deathmatch::OnRender				()
{
	inherited::OnRender();
	/*
	for (int i0 = 0; i0<int(rpoints[0].size())-1; i0++)
	{
		Fvector v0 = rpoints[0][i0].P;
		for (int i1=i0+1; i1<int(rpoints[0].size()); i1++)
		{
			Fvector v1 = rpoints[0][i1].P;
			bool			failed = !m_graph_engine->search(*m_level_graph,m_level_graph->vertex(u32(-1),v0),m_level_graph->vertex(u32(-1),v1),&xPath,GraphEngineSpace::CBaseParameters());
			if (failed) continue;

			xr_vector<u32>::const_iterator I = xPath.begin();
			xr_vector<u32>::const_iterator E = xPath.end();
			for ( ; I != E; ++I) {
				RCache.dbg_DrawAABB(
					Fvector().set(
					m_level_graph->vertex_position(*I)
					).add(
					Fvector().set(0.f,.025f,0.f)
					),
					.05f,
					.05f,
					.05f,
					0xff00ff00
					);
				if (I!=E-1)
				{
					Fvector p0 = m_level_graph->vertex_position(*I);
					Fvector p1 = m_level_graph->vertex_position(*(I+1));
					RCache.dbg_DrawLINE(Fidentity, 
						p0,
						p1,
						0xff00ff00);
				}

			}
		}
	}
	*/
};
#endif
//  [7/5/2005]

void		game_sv_Deathmatch::check_for_WarmUp()
{
	if (m_dwWarmUp_MaxTime == 0) return;
	if (m_dwWarmUp_CurTime == 0) return;
	if (m_dwWarmUp_CurTime < Level().timeServer())
	{
		m_dwWarmUp_CurTime = 0;
		Console->Execute("g_restart_fast");
	};
};

void		game_sv_Deathmatch::on_death	(CSE_Abstract *e_dest, CSE_Abstract *e_src)
{
	CSE_ALifeCreatureActor	*pVictim= smart_cast<CSE_ALifeCreatureActor*>(e_dest);
	if (!pVictim)
		return;
}

void		game_sv_Deathmatch::OnPlayer_Sell_Item		(ClientID id_who, NET_Packet &P)
{
	game_PlayerState*	ps	=	get_id	(id_who);
	if (!ps || ps->testFlag(GAME_PLAYER_FLAG_VERY_VERY_DEAD)) return;

	CSE_ALifeCreatureActor*		e_Actor	= smart_cast<CSE_ALifeCreatureActor*>(get_entity_from_eid	(ps->GameID));
	if (!e_Actor) return;

	u16 ItemsCount = P.r_u16();
	for (u16 i=0; i<ItemsCount; i++)
	{
		u16 ItemID = P.r_u16();	
		CSE_Abstract* eItem = get_entity_from_eid		(ItemID);
		if (!eItem) continue;

		if (eItem->ID_Parent != ps->GameID) continue;

		u16 ItemCost = 0;		
		if (!GetBuyableItemCost(*eItem->s_name, &ItemCost)) continue;
		//-----------------------------------------------------------------
		Player_AddMoney(ps, ItemCost/2);
		//-----------------------------------------------------------------
		NET_Packet			nP;
		u_EventGen			(nP,GE_DESTROY,eItem->ID);
		Level().Send(nP,net_flags(TRUE,TRUE));
		//-----------------------------------------------------------------
	};
	signal_Syncronize();
};